
from pyloadl import *

"""

 rc = ll_start_job_ext(step_id, node_list, adapter_list)

 Return Values :

    rc           - Return code for operation

 Parameters :

    step_id      - Represents the step ID of the job step to be started. 

    node_list    - List of node names where the job will be started. 
                   The first member of the list is the parallel master node.

    adapter_list - List of Lists of adapter information for each node.
                   The members of this list are: 
                       dev_name  - Device name of adapter to be used such as css0
                       protocol  - Communication protocol this usage supports.
                                   Valid values are MPI, LAPI, and MPI_LAPI. 
                       subsystem - communication subsystem this usage supports.
                                   Valid values are IP or US. 
                       wid       - For US subsystem usages, this indicates which adapter 
                                   window ID to use. For IP subsystem usages, this field is ignored. 
                       mem       - For US subsystem usages, this is the amount of adapter 
                                   memory to dedicate to the adapter usage. 
                                   For IP subsystem usages, this field is ignored. 

 Each element in the adapterUsage list represents one communication channel for a task.
 If the subsystem is US (User Space), a communication channel will require a switch adapter window.
 Adapter windows, and User Space usages, must be specified on actual switch adapters that are only
 accessible if AGGREGATE_ADAPTERS=False is specified in the configuration file.

 NOTE: Obviously this requires that the scheduler type be set to API
""" 

step_id = "shivling.58.0"
node_list = ["shivling"]
adapter_list = [["en0","MPI","IP",0,0]]

rc = ll_start_job_ext(step_id, node_list, adapter_list)

print "ll_start_job_ext: returns %d" % rc
