from pyloadl import *
from sys import exit
from string import join

"""

   Displays information on the LoadLeveler cluster

   RESERVATION_WAITING - 0
   RESERVATION_SETUP - 1
   RESERVATION_ACTIVE - 2 
   RESERVATION_ACTIVE_SHARED - 3
   RESERVATION_CANCEL - 4
   RESERVATION_COMPLETE - 5

   RESERVATION_DEFAULT_MODE = 0
   RESERVATION_SHARED = (1<<0)
   RESERVATION_REMOVE_ON_IDLE = (1<<1)

   RESERVATION_START_TIME - 0 char *
   RESERVATION_ADD_START_TIME - 1 int
   RESERVATION_DURATION -2 int
   RESERVATION_ADD_DURATION - 3 int
   RESERVATION_BY_NODE - 4 int
   RESERVATION_ADD_NUM_NODE - 5 int 
   RESERVATION_BY_HOSTLIST - 6  char **, NULL terminated
   RESERVATION_ADD_HOSTS - 7    char **, NULL terminated
   RESERVATION_DEL_HOSTS - 8    char **, NULL terminated
   RESERVATION_BY_JOBSTEP - 9   char *
   RESERVATION_BY_JCF - 10      char * 
   RESERVATION_USERLIST,        char **, NULL terminated
   RESERVATION_ADD_USERS,       char **, NULL terminated
   RESERVATION_DEL_USERS,       char **, NULL terminated
   RESERVATION_GROUPLIST,       char **, NULL terminated
   RESERVATION_ADD_GROUPS,      char **, NULL terminated
   RESERVATION_DEL_GROUPS,      char **, NULL terminated
   RESERVATION_MODE_SHARED,     int 0=Not Shared, 1=Share
   RESERVATION_MODE_REMOVE_ON_IDLE,    int 0=Don't Remove, 1=Remove
   RESERVATION_OWNER,          char * 
   RESERVATION_GROUP           char *
 
   RESERVATION_OK                      0 /* Success */
   RESERVATION_LIMIT_EXCEEDED         -1 /* Exceeds max # of reservations allowed in the LoadLeveler cluster */
   RESERVATION_TOO_CLOSE              -2 /* Reservation is being made within the minimum advance time */
   RESERVATION_NO_STORAGE             -3 /* The system cannot allocate memory  */
   RESERVATION_CONFIG_ERR             -4 /* Errors encountered processing the LL admin/config files */
   RESERVATION_CANT_TRANSMIT          -5 /* A data transmission failure occurred */
   RESERVATION_GROUP_LIMIT_EXCEEDED   -6 /* Exceeds max # of reservations for the group */
   RESERVATION_USER_LIMIT_EXCEEDED    -7 /* Exceeds max # of reservations for the user */
   RESERVATION_SCHEDD_CANT_CONNECT    -8 /* Schedd cannot connect to CM */
   RESERVATION_API_CANT_CONNECT       -9 /* API cannot connect to the Schedd or CM */
   RESERVATION_JOB_SUBMIT_FAILED      -10 /* Submit of job command file failed */
   RESERVATION_NO_MACHINE             -11 /* One or more machines in the hostlist are not in the LoadLeveler cluster */
   RESERVATION_WRONG_MACHINE          -12 /* Reservations not permitted on one or more machines in the hostlist  */
   RESERVATION_NO_RESOURCE            -13 /* Insufficient resources in the LoadLeveler cluster */
   RESERVATION_NOT_SUPPORTED          -14 /* The scheduler in use does not support Advance Reservation  */
   RESERVATION_NO_JOBSTEP             -15 /* The jobstep used for node selection doesn't exist */
   RESERVATION_WRONG_JOBSTEP          -16 /* The jobstep used for node selection isn't in the right state */
   RESERVATION_NOT_EXIST              -17 /* The reservation does not exist */
   RESERVATION_REQUEST_DATA_NOT_VALID -18 /* Invalid input */
   RESERVATION_NO_PERMISSION          -19 /* Permission cannot be granted */
   RESERVATION_TOO_LONG               -20 /* Duration exceeds max allowed */
   RESERVATION_WRONG_STATE            -21 /* Reservation state is not right for the requested operation */
   RESERVATION_NO_DCE_CRED            -30 /* DCE is enabled, the user has no credentials */
   RESERVATION_INSUFFICIENT_DCE_CRED  -31 /* DCE is enabled, credential lifetime < 5 minutes */

"""

print "LoadLeveler version     : %s" % ll_version()

rc = ll_make_reservation( "06/16 23:00", 600, 9, "shivling.239.0")

